"""
Script for automated generation of fixtures.
"""
import sys, os

from django.core import serializers

from poem.models import *

FIXTURES = { 'metric_set.json': MetricSet.objects.all(),
             'expressions.json': Expression.objects.all(),
             'extensions.json': Extension.objects.all(),
             'groups.json': GroupReference.objects.all(),
             'profiles.json': Profile.objects.all(),
            }

def create_fixture(queryset, out):
    object_list = list(queryset)
    serializers.serialize('json', object_list, stream=out)
    
if __name__ == '__main__':
    for fixture in FIXTURES:
        # fileh = open(settings.CLUMAN_PATH+'/cluman/cluman_mw/fixtures/'+fixture, 'w')
        fileh = open(os.path.join(sys.argv[1], fixture), 'w')
        print fileh.name
        qs = FIXTURES[fixture]
        create_fixture(qs, fileh)
        fileh.close()    