import httplib, urlparse

from django.utils import simplejson
from django.conf import settings

def fetch_url(uri):
    uri_obj = urlparse.urlparse(uri)
    connection = httplib.HTTPConnection(uri_obj[1])
    connection.request('GET', uri)
    response = connection.getresponse()
    return (response, response.read())

def get_hints(attribute):
    (response, content) = fetch_url(settings.SUGGESTION_URIS[attribute])
    
    if response.status == 200:
        json_feed = simplejson.JSONDecoder().decode(content)
        json_attrib = settings.SUGGESTION_KEYS[attribute]
        clean_values = set(map(lambda x:x[json_attrib], json_feed))
        return (True, clean_values)
    else:
        return (False, None)
