from django.conf.urls.defaults import patterns, url 
from piston import resource 

from Poem.poem_api import handlers

urlpatterns = patterns('',
    # Backward compatible API
    url(r'^0.1/(?P<emitter_format>.+)/namespace/$', 
                            resource.Resource(handler=handlers.NamespaceHandler)),                      
    url(r'^0.1/json/profiles/$', 
                            resource.Resource(handler=handlers.CompProfileHandler)),
    url(r'^0.1/json/profiles/(?P<id>[^/]+)/$', 
                            resource.Resource(handler=handlers.CompProfileHandler)), 
    url(r'^0.1/json/hints/metrics/$', 
                            resource.Resource(handler=handlers.MetricHandler),
                            name='poem_metric_hints'),
    url(r'^0.1/json/expressions/$', 
                            resource.Resource(handler=handlers.ExpressionHandler)),
    url(r'^0.1/json/hints/(?P<attribute>.+)/$',  
                            resource.Resource(handler=handlers.SuggestionHandler),
                            name='poem_external_hints'),
    url(r'^0.1/json/tags/$', resource.Resource(handler=handlers.TagsHandler), 
                            name='taggit_autocomplete-list' ),
    # new API
    url(r'^0.2/(?P<emitter_format>.+)/namespace/$', 
                            resource.Resource(handler=handlers.NamespaceHandler)),                      
    url(r'^0.2/(?P<emitter_format>.+)/profiles/$', 
                            resource.Resource(handler=handlers.ProfileHandler)),
    url(r'^0.2/(?P<emitter_format>.+)/profiles/(?P<id>[^/]+)/$', 
                            resource.Resource(handler=handlers.ProfileHandler)), 
    url(r'^0.2/json/hints/metrics/$', 
                            resource.Resource(handler=handlers.MetricHandler),
                            name='poem_metric_hints'),
    url(r'^0.2/json/hints/(?P<attribute>.+)/$',  
                            resource.Resource(handler=handlers.SuggestionHandler),
                            name='poem_external_hints'),
    url(r'^0.2/json/tags/$', resource.Resource(handler=handlers.TagsHandler), 
                            name='taggit_autocomplete-list' ),
) 

