ALTER TABLE "POEM_PROFILE" add "VALID" NUMBER(1) CHECK ("VALID" IN (0,1));
ALTER TABLE "POEM_PROFILE" modify "OWNER" NVARCHAR2(255);

ALTER TABLE "POEM_GROUPREFERENCE" add "DESCRIPTION" NVARCHAR2(255) ;
ALTER TABLE "POEM_GROUPREFERENCE" add "IS_DELETED" NVARCHAR2(1);

CREATE TABLE "POEM_USERPROFILE" (
    "ID" NUMBER(11) NOT NULL PRIMARY KEY,
    "USER_ID" NUMBER(11) NOT NULL UNIQUE REFERENCES "AUTH_USER" ("ID") DEFERRABLE INITIALLY DEFERRED,
    "LAST_LOGIN" TIMESTAMP,
    "SUBJECT" NVARCHAR2(255)
)
;

DECLARE
    i INTEGER;
BEGIN
    SELECT COUNT(*) INTO i FROM USER_CATALOG
        WHERE TABLE_NAME = 'POEM_USERPROFILE_SQ' AND TABLE_TYPE = 'SEQUENCE';
    IF i = 0 THEN
        EXECUTE IMMEDIATE 'CREATE SEQUENCE "POEM_USERPROFILE_SQ"';
    END IF;
END;
/

CREATE OR REPLACE TRIGGER "POEM_USERPROFILE_TR"
BEFORE INSERT ON "POEM_USERPROFILE"
FOR EACH ROW
WHEN (new."ID" IS NULL)
    BEGIN
        SELECT "POEM_USERPROFILE_SQ".nextval
        INTO :new."ID" FROM dual;
    END;
/

-- Schema Version
INSERT INTO schema_details(ver,creation_date,remarks,db_name) VALUES('1.2', sysdate, 'Version 1.2 of the schema', 'poem');



