CREATE TABLE "TAGGIT_TAG" (
    "ID" NUMBER(11) NOT NULL PRIMARY KEY,
    "NAME" NVARCHAR2(100),
    "SLUG" NVARCHAR2(100) UNIQUE
)
;

DECLARE
    i INTEGER;
BEGIN
    SELECT COUNT(*) INTO i FROM USER_CATALOG
        WHERE TABLE_NAME = 'TAGGIT_TAG_SQ' AND TABLE_TYPE = 'SEQUENCE';
    IF i = 0 THEN
        EXECUTE IMMEDIATE 'CREATE SEQUENCE "TAGGIT_TAG_SQ"';
    END IF;
END;
/

CREATE OR REPLACE TRIGGER "TAGGIT_TAG_TR"
BEFORE INSERT ON "TAGGIT_TAG"
FOR EACH ROW
WHEN (new."ID" IS NULL)
    BEGIN
        SELECT "TAGGIT_TAG_SQ".nextval
        INTO :new."ID" FROM dual;
    END;
/
CREATE TABLE "TAGGIT_TAGGEDITEM" (
    "ID" NUMBER(11) NOT NULL PRIMARY KEY,
    "TAG_ID" NUMBER(11) NOT NULL REFERENCES "TAGGIT_TAG" ("ID") DEFERRABLE INITIALLY DEFERRED,
    "OBJECT_ID" NUMBER(11) NOT NULL,
    "CONTENT_TYPE_ID" NUMBER(11) NOT NULL REFERENCES "DJANGO_CONTENT_TYPE" ("ID") DEFERRABLE INITIALLY DEFERRED
)
;

DECLARE
    i INTEGER;
BEGIN
    SELECT COUNT(*) INTO i FROM USER_CATALOG
        WHERE TABLE_NAME = 'TAGGIT_TAGGEDITEM_SQ' AND TABLE_TYPE = 'SEQUENCE';
    IF i = 0 THEN
        EXECUTE IMMEDIATE 'CREATE SEQUENCE "TAGGIT_TAGGEDITEM_SQ"';
    END IF;
END;
/

CREATE OR REPLACE TRIGGER "TAGGIT_TAGGEDITEM_TR"
BEFORE INSERT ON "TAGGIT_TAGGEDITEM"
FOR EACH ROW
WHEN (new."ID" IS NULL)
    BEGIN
        SELECT "TAGGIT_TAGGEDITEM_SQ".nextval
        INTO :new."ID" FROM dual;
    END;
/
CREATE INDEX "TAGGIT_TAGGEDITEM_TAG_ID" ON "TAGGIT_TAGGEDITEM" ("TAG_ID");
CREATE INDEX "TAGGIT_TAGGEDITEM_OBJECT_ID" ON "TAGGIT_TAGGEDITEM" ("OBJECT_ID");
CREATE INDEX "TAGGIT_TAGGEDITEM_CONTENT_2460" ON "TAGGIT_TAGGEDITEM" ("CONTENT_TYPE_ID");

CREATE INDEX "DJANGO_SESSION_C25C2C28" ON "DJANGO_SESSION" ("EXPIRE_DATE");

INSERT INTO schema_details(ver,creation_date,remarks,db_name) VALUES('1.4', sysdate, 'Version 1.4 of the schema', 'poem');
COMMIT;